unit IOB;
interface
uses CRTp2;
const BA1 = $3F8;                           { COM 1 }
      BA2 = $2F8;                           { COM 2 }
      BA3 = $3E8;                           { COM 3 }
      BA4 = $2E8;                           { COM 4 }
var com : byte;

procedure COM1;
procedure COM2;
procedure COM3;
procedure COM4;
procedure reset;
procedure Vystup(dout :byte;var vst:byte);
procedure Vystup2(dout1,dout2 : byte; var DCD,DSR,RI,CTS:byte);
procedure graficky;
procedure vstup_c(pomoc:integer; var v1,v2,v3,v4,v5,v6,v7,v8 : integer);
function in1(vst:byte):byte;
function in2(vst:byte):byte;
function in3(vst:byte):byte;
function in4(vst:byte):byte;
function in5(vst:byte):byte;
function in6(vst:byte):byte;
function in7(vst:byte):byte;
function in8(vst:byte):byte;

implementation

procedure COM1;
begin
com :=0;
end;

procedure COM2;
begin
com:=2
end;

procedure COM3;
begin
com := 3;
end;

procedure COM4;
begin
com := 4;
end;

procedure reset;
var Dout1,dout2 : Byte;
    Stelle, n, m  : Integer;
begin
  dout1 := 255;
  dout2 := 255;

if com = 0 then begin
  Port [BA1+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                        { Verzgerung }
  Port [BA1+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((dout2 AND Stelle) > 0) then        { Bits 8...15 }
      Port [BA1+3] := 64                    { Daten an TXD }
      else Port [BA1+3] := 0;
    Port [Ba1+4] := 1;                      { Clock an  (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA1+4] := 0;                      { Clock aus (DTR) }
  end;
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((Dout1 AND Stelle) > 0) then
      Port [BA1+3] := 64                    { Daten ausgeben (TXD) }
      else Port [BA1+3] := 0;
    Port [Ba1+4] := 1;                      { Clock an (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA1+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA1+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA1+4] := 0;                        { Strobe aus (RTS) }
end;

if com = 2 then begin
  Port [BA2+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                        { Verzgerung }
  Port [BA2+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((dout2 AND Stelle) > 0) then        { Bits 8...15 }
      Port [BA2+3] := 64                    { Daten an TXD }
      else Port [BA2+3] := 0;
    Port [Ba2+4] := 1;                      { Clock an  (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA2+4] := 0;                      { Clock aus (DTR) }
  end;
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((Dout1 AND Stelle) > 0) then
      Port [BA2+3] := 64                    { Daten ausgeben (TXD) }
      else Port [BA2+3] := 0;
    Port [Ba2+4] := 1;                      { Clock an (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA2+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA2+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA2+4] := 0;                        { Strobe aus (RTS) }
end;

if com = 3 then begin
  Port [BA3+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                        { Verzgerung }
  Port [BA3+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((dout2 AND Stelle) > 0) then        { Bits 8...15 }
      Port [BA3+3] := 64                     { Daten an TXD }
      else Port [BA3+3] := 0;
    Port [Ba3+4] := 1;                      { Clock an  (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA3+4] := 0;                      { Clock aus (DTR) }
  end;
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((Dout1 AND Stelle) > 0) then
      Port [BA3+3] := 64                    { Daten ausgeben (TXD) }
      else Port [BA3+3] := 0;
    Port [Ba3+4] := 1;                      { Clock an (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA3+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA3+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA3+4] := 0;                        { Strobe aus (RTS) }
end;

if com = 4 then begin
  Port [BA4+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                        { Verzgerung }
  Port [BA4+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((dout2 AND Stelle) > 0) then        { Bits 8...15 }
      Port [BA4+3] := 64                    { Daten an TXD }
      else Port [BA4+3] := 0;
    Port [Ba4+4] := 1;                      { Clock an  (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA4+4] := 0;                      { Clock aus (DTR) }
  end;
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((Dout1 AND Stelle) > 0) then
      Port [BA4+3] := 64                    { Daten ausgeben (TXD) }
      else Port [BA4+3] := 0;
    Port [Ba4+4] := 1;                      { Clock an (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA4+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA4+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA4+4] := 0;                        { Strobe aus (RTS) }
end;

end;

procedure Vystup(dout :byte;var vst:byte);
var Stelle, n, m  : Integer;
begin
  vst:=0;
if com = 0 then begin
  Port [BA1+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                        { Verzgerung }
  Port [BA1+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((dout AND Stelle) > 0) then
      Port [BA1+3] := 64                    { Daten an TXD }
      else Port [BA1+3] := 0;
    if (Port[BA1+6] AND 128) = 128          { Daten lesen (DCD) }
       then vst := vst + Stelle;
    Port [Ba1+4] := 1;                      { Clock an  (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA1+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA1+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA1+4] := 0;                        { Strobe aus (RTS) }
end;

if com = 2 then begin
  Port [BA2+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 20 do;                        { Verzgerung }
  Port [BA2+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((dout AND Stelle) > 0) then
      Port [BA2+3] := 64                    { Daten an TXD }
      else Port [BA2+3] := 0;
    if (Port[BA2+6] AND 128) = 128          { Daten lesen (DCD) }
       then vst := vst + Stelle;
    Port [Ba2+4] := 1;                      { Clock an  (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 40 do;
    Port [BA2+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA2+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 20 do;
  Port [BA2+4] := 0;                        { Strobe aus (RTS) }
end;

if com = 3 then begin
  Port [BA3+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                        { Verzgerung }
  Port [BA3+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((dout AND Stelle) > 0) then
      Port [BA3+3] := 64                    { Daten an TXD }
      else Port [BA3+3] := 0;
    if (Port[BA3+6] AND 128) = 128          { Daten lesen (DCD) }
       then vst := vst + Stelle;
    Port [Ba3+4] := 1;                      { Clock an  (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA3+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA3+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA3+4] := 0;                        { Strobe aus (RTS) }
end;

if com = 4 then begin
  Port [BA4+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                        { Verzgerung }
  Port [BA4+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((dout AND Stelle) > 0) then
      Port [BA4+3] := 64                    { Daten an TXD }
      else Port [BA4+3] := 0;
    if (Port[BA4+6] AND 128) = 128          { Daten lesen (DCD) }
       then vst := vst + Stelle;
    Port [Ba4+4] := 1;                      { Clock an  (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA4+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA4+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA4+4] := 0;                        { Strobe aus (RTS) }
end;

end;


procedure Vystup2(dout1,dout2 : byte; var DCD,DSR,RI,CTS:byte);
var Stelle, StelleAD,m, n : Integer;
begin
  DCD := 0;
  DSR := 0;
  RI  := 0;
  CTS := 0;

if com = 0 then begin
  Port [BA1+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                        { Verzgerung }
  Port [BA1+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((dout2 AND Stelle) > 0) then        { Bits 8...15 }
      Port [BA1+3] := 64                    { Daten an TXD }
      else Port [BA1+3] := 0;
    if (Port[BA1+6] AND 16) = 16            { Daten lesen (CTS) }
       then CTS := CTS + Stelle;
    if (Port[BA1+6] AND 64) = 64            { Daten lesen (RI) }
       then RI := RI + Stelle;
    if (Port[BA1+6] AND 32) = 32            { Daten lesen (DSR) }
       then DSR := DSR + Stelle;
    if (Port[BA1+6] AND 128) = 128          { Daten lesen (DCD) }
       then DCD := DCD + Stelle;
    Port [Ba1+4] := 1;                      { Clock an  (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA1+4] := 0;                      { Clock aus (DTR) }
  end;
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((Dout1 AND Stelle) > 0) then
      Port [BA1+3] := 64                    { Daten ausgeben (TXD) }
      else Port [BA1+3] := 0;
    Port [Ba1+4] := 1;                      { Clock an (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA1+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA1+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA1+4] := 0;                        { Strobe aus (RTS) }
end;

if com = 2 then begin
  Port [BA2+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                        { Verzgerung }
  Port [BA2+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((dout2 AND Stelle) > 0) then        { Bits 8...15 }
      Port [BA2+3] := 64                    { Daten an TXD }
      else Port [BA2+3] := 0;
    if (Port[BA2+6] AND 16) = 16            { Daten lesen (CTS) }
       then CTS := CTS + Stelle;
    if (Port[BA2+6] AND 64) = 64            { Daten lesen (RI) }
       then RI := RI + Stelle;
    if (Port[BA2+6] AND 32) = 32            { Daten lesen (DSR) }
       then DSR := DSR + Stelle;
    if (Port[BA2+6] AND 128) = 128          { Daten lesen (DCD) }
       then DCD := DCD + Stelle;
    Port [Ba2+4] := 1;                      { Clock an  (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA2+4] := 0;                      { Clock aus (DTR) }
  end;
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((Dout1 AND Stelle) > 0) then
      Port [BA2+3] := 64                    { Daten ausgeben (TXD) }
      else Port [BA2+3] := 0;
    Port [Ba2+4] := 1;                      { Clock an (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA2+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA2+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA2+4] := 0;                        { Strobe aus (RTS) }
end;

if com = 3 then begin
  Port [BA3+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                        { Verzgerung }
  Port [BA3+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((dout2 AND Stelle) > 0) then        { Bits 8...15 }
      Port [BA3+3] := 64                     { Daten an TXD }
      else Port [BA3+3] := 0;
    if (Port[BA3+6] AND 16) = 16             { Daten lesen (CTS) }
       then CTS := CTS + Stelle;
    if (Port[BA3+6] AND 64) = 64            { Daten lesen (RI) }
       then RI := RI + Stelle;
    if (Port[BA3+6] AND 32) = 32            { Daten lesen (DSR) }
       then DSR := DSR + Stelle;
    if (Port[BA3+6] AND 128) = 128          { Daten lesen (DCD) }
       then DCD := DCD + Stelle;
    Port [Ba3+4] := 1;                      { Clock an  (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA3+4] := 0;                      { Clock aus (DTR) }
  end;
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((Dout1 AND Stelle) > 0) then
      Port [BA3+3] := 64                    { Daten ausgeben (TXD) }
      else Port [BA3+3] := 0;
    Port [Ba3+4] := 1;                      { Clock an (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA3+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA3+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA3+4] := 0;                        { Strobe aus (RTS) }
end;

if com = 4 then begin
  Port [BA4+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                        { Verzgerung }
  Port [BA4+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((dout2 AND Stelle) > 0) then        { Bits 8...15 }
      Port [BA4+3] := 64                    { Daten an TXD }
      else Port [BA4+3] := 0;
    if (Port[BA4+6] AND 16) = 16            { Daten lesen (CTS) }
       then CTS := CTS + Stelle;
    if (Port[BA4+6] AND 64) = 64            { Daten lesen (RI) }
       then RI := RI + Stelle;
    if (Port[BA4+6] AND 32) = 32            { Daten lesen (DSR) }
       then DSR := DSR + Stelle;
    if (Port[BA4+6] AND 128) = 128          { Daten lesen (DCD) }
       then DCD := DCD + Stelle;
    Port [Ba4+4] := 1;                      { Clock an  (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA4+4] := 0;                      { Clock aus (DTR) }
  end;
  Stelle := 1;
  for n:=1 to 8 do begin
    if ((Dout1 AND Stelle) > 0) then
      Port [BA4+3] := 64                    { Daten ausgeben (TXD) }
      else Port [BA4+3] := 0;
    Port [Ba4+4] := 1;                      { Clock an (DTR) }
    Stelle := Stelle * 2;
    for m := 1 to 20 do;
    Port [BA4+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA4+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA4+4] := 0;                        { Strobe aus (RTS) }
end;

end;

procedure graficky;

var a,b,c,d,e,f,g,h : integer;
begin

     if a=1 then begin window(4,5,5,5);
     textbackground(3);
     clrscr;
     end;

     if b=1 then begin window(8,5,9,5);
     textbackground(3);
     clrscr;
     end;

     if c=1 then begin window(12,5,13,5);
     textbackground(3);
     clrscr;
     end;

     if d=1 then begin window(16,5,17,5);
     textbackground(3);
     clrscr;
     end;

     if e=1 then begin window(20,5,21,5);
     textbackground(3);
     clrscr;
     end;

     if f=1 then begin window(24,5,25,5);
     textbackground(3);
     clrscr;
     end;

     if g=1 then begin window(28,5,29,5);
     textbackground(3);
     clrscr;
     end;

     if h=1 then begin window(32,5,33,5);
     textbackground(3);
     clrscr;

end;
end;

procedure vstup_c(pomoc:integer; var v1,v2,v3,v4,v5,v6,v7,v8 : integer);
var                 n : integer;
begin
  v1:=0;
  v2:=0;
  v3:=0;
  v4:=0;
  v5:=0;
  v6:=0;
  v7:=0;
  v8:=0;
  if pomoc = 255 then begin end;
  if pomoc mod 2 =0 then begin v1:=1; end;
  if pomoc div 2 mod 2 =0 then begin v2:=1; end;
  if pomoc div 4 mod 2 =0 then begin v3:=1; end;
  if pomoc div 8 mod 2 =0 then begin v4:=1; end;
  if pomoc div 16 mod 2 =0 then begin v5:=1; end;
  if pomoc div 32 mod 2 =0 then begin v6:=1; end;
  if pomoc div 64 mod 2 =0 then begin v7:=1; end;
  if pomoc div 128 mod 2 =0 then begin v8:=1; end;
  if pomoc = 0 then begin end;
end;

function in1(vst:byte):byte;
begin
in1:=0;
if vst mod 2 = 0 then in1:=1;
end;

function in2(vst:byte):byte;
begin
in2:=0;
if vst div 2 mod 2 = 0 then in2:=1;
end;


function in3(vst:byte):byte;
begin
in3:=0;
if vst div 4 mod 2 = 0 then in3:=1;
end;

function in4(vst:byte):byte;
begin
in4:=0;
if vst div 8 mod 2 = 0 then in4:=1;
end;

function in5(vst:byte):byte;
begin
in5:=0;
if vst div 16 mod 2 = 0 then in5:=1;
end;

function in6(vst:byte):byte;
begin
in6:=0;
if vst div 32 mod 2 = 0 then in6:=1;
end;

function in7(vst:byte):byte;
begin
in7:=0;
if vst div 64 mod 2 = 0 then in7:=1;
end;

function in8(vst:byte):byte;
begin
in8:=0;
if vst div 128 mod 2 = 0 then in8:=1;
end;

end.