unit Jaromir;
interface
{$M 8192,0,0}
uses CRTp2,DOS,GRAPH;

function Centrovani(S : string) : string;
function prevod (vstup:integer):string;
procedure spust (jmeno : string);
procedure novy (jmeno : string);
procedure pripis_cislo (jmeno : string ; radka : integer) ;
procedure pripis (jmeno : string ; radka : string) ;
procedure smaz (jmeno : string);
procedure cti_cislo (jmeno : string ;i : integer ;var radka:byte);
procedure cti (jmeno : string ;i : integer ;var radka:string);
procedure radka (jmeno : string ; cislo :integer;radka : string) ;
procedure Kopie(Zdroj,Cil : String);
Function  Existuje(Jmeno : PathStr) : boolean;
FUNCTION  Misto(cislo_disku:byte):longint;


implementation

function Centrovani(S : string) : string;
var
   I : byte;
begin
  for I := 1 to (80 - Length(S)) DIV 2 do
    S := ' ' + S;
  Centrovani := S;
end;

function prevod (vstup:integer):string;
var
vstup1:integer;
vystup2,vystup:string;
begin
 vystup:='';
 prevod:='';
 repeat
   vstup1:=vstup mod 10;
   vstup:=trunc(vstup div 10);
	CASE vstup1 OF
	 0:vystup2:='0';
	 1:vystup2:='1';
	 2:vystup2:='2';
	 3:vystup2:='3';
	 4:vystup2:='4';
	 5:vystup2:='5';
	 6:vystup2:='6';
	 7:vystup2:='7';
	 8:vystup2:='8';
	 9:vystup2:='9';
	END;
   vystup:=vystup2+vystup;
 until vstup = 0;
prevod:=vystup;
end;


Function Existuje(Jmeno : PathStr) : boolean;
var
   F : file   ;
begin
   Assign(F,Jmeno);
   Reset(F);
   if IOResult=0 then
   begin
      Close(F);
      Existuje := True;
   end
   else
      Existuje := False;
end;

procedure spust (jmeno : string);
{$M 8192,0,0}
begin
    SwapVectors;
    Exec(GetEnv('COMSPEC'), '/C ' + jmeno);
    SwapVectors;
    if DosError <> 0 then
      WriteLn('Chyba, nelze spustit COMMAND.COM');
    WriteLn;
end;

procedure novy(jmeno : string);
var
   F : text;
begin
   Assign(F, jmeno);
   Rewrite(F);
   Close(F);
end;

procedure pripis (jmeno : string ; radka : string) ;
var
   F : text;
begin
   Assign(F,jmeno );
   Append(F);
   WriteLn(F,radka);
   Close(F);
end;

procedure pripis_cislo (jmeno : string ; radka : integer) ;
var
   F : text;
begin
   Assign(F,jmeno );
   Append(F);
   WriteLn(F,radka);
   Close(F);
end;

procedure radka (jmeno : string ;cislo:integer; radka : string) ;
var
   F,F1 : text;
   jmeno1,Line : string;
   x : integer;
begin
   jmeno1 := 'pok.bak';
   kopie(jmeno,jmeno1);
   Assign(F,jmeno );
   rewrite(F);
   assign(F1,jmeno1);
   reset(F1);
   x:=0;
   while not(Eof(F1)) do
   begin
      ReadLn(F1,Line);
      if x = cislo then WriteLn(F,radka);
      writeln(F,Line);
      inc(x);
   end;
   close(F1);
   Close(F);
end;

procedure smaz (jmeno : string);
begin
spust ('del ' + jmeno );
end;

procedure cti (jmeno : string ;i : integer ;var radka:string);
var
   F   : text;
   Line: string;
   x : integer;
begin
   Assign(F,jmeno);
   Reset(F);
   x:=0;
   while not(Eof(F)) do
   begin
      ReadLn(F,Line);
      if x = i then radka := Line;
      inc(x);
   end;
   Close(F);
end;

procedure cti_cislo (jmeno : string ;i : integer ;var radka:byte);
var
   F   : text;
   Line: integer;
   x : integer;
begin
   Assign(F,jmeno);
   Reset(F);
   x:=0;
   while not(Eof(F)) do
   begin
      ReadLn(F,Line);
      if x = i then radka := Line;
      inc(x);
   end;
   Close(F);
end;

procedure Kopie(Zdroj,Cil : String);
{$I-}
type
  InfoRec = record
    Zd,Cl     : PathStr; { jmna diskovch soubor }
    F1,F2     : file;    { promnn netypovch soubor }
    Buffer    : pointer; { ukazatel na blok pamti uren pro
                           penos dat, maximln velikost bloku
                           je 64 KB }
    Velikost  : word;    { aktuln velikost bloku pamti }
    OK        : boolean; { informace o sprvnosti operace }
  end;

procedure Otevri(var C : InfoRec);
{ oteve diskov soubory, existujc soubor zdroje a nov
  soubor, kam se bude ukldat obsah pvodnho souboru }
begin
  with C do
  begin
    Assign(F1, Zd);     { piad promnn F1 zdrojov s. }
    Reset(F1,1);        { oteve diskov soubor a definuje
    OK:=False;           velikost penenho bloku }
    if IOResult<>0 then { test sprvnosti oteen souboru }
       Exit;
    if Existuje(Cl) then
    begin               { jestlie diskov soubor, do
                          kterho se m kopie uloit
                          existuje }
        Close(F1);      { uzavi soubor zdroje }
        Exit;           { ukoni proceduru }
    end;
    Assign(F2, Cl);     { oteven clovho souboru }
    Rewrite(F2, 1);
    if IOResult<>0 then { test sprvnosti oteven cle }
    begin
       Close(F1);
       Exit;
    end;
    OK := True;         { jestlie jsou oba soubory oteveny }
  end;
end;

procedure GetBuffer(var C : InfoRec);
{ vymez blok pamti pro penos dat }
begin
  with C do
  begin
    OK := False;        { blok nelze vymezit }
    if MaxAvail > $FFF8 then
    begin
       Velikost := $FFF8;
       OK:= true;
    end
    else
       Exit;
    GetMem(Buffer, Velikost);
                        { vymezen bloku pamti }
  end;
end;

procedure ReadWrite(var C : InfoRec);
{ zajiuje ten ze zdroje a zpis do cle, pokud probhne
operace korektn, promnn OK se nastav na TRUE }
var
    B : word;
begin
  with C do
  begin
    OK := False;
    repeat
      BlockRead(F1, Buffer^, Velikost, B);
      { ten ze zdrojovho souboru do bloku pamti }
      If IOResult<>0 then{ test sprvnosti V/V operace }
      begin
        Close(F1);      { uzaven soubor }
        Close(F2);
        Erase(F2);      { mazn clovho souboru }
        Exit;
      end;
      BlockWrite(F2, Buffer^, B, B);
     { zpis natenho potu blok do clovho souboru }
      if IOResult <> 0 then
      begin
        Close(F1);
        Close(F2);
        Erase(F2);
        Exit;
      end;
    until B=0;          { zastav koprovn po zpisu vech
                          blok }
    OK := True;
  end;
end;

var C : InfoRec;

begin
  with C do
  begin
    Zd := Zdroj;
    Cl := Cil;
    Otevri(C);
    if not OK then
       Exit;
    GetBuffer(C);
    if OK then
    begin
      ReadWrite(C);
      FreeMem(Buffer, Velikost);
    end;
    if not OK then
        Exit;
    Close(C.F1);
    Close(C.F2);
    Writeln('Kopie probehla korektne....');
   end;
end;

FUNCTION  Misto(cislo_disku:byte):longint;
 VAR
  DSA                 :longint;
  DFA                 :longint;

 BEGIN
  {$I-}
  DSA:=0;
  DFA:=0;
  DSA:=DiskSize(cislo_disku);
  IF(DSA<> -1)
  THEN
   BEGIN
    DFA:=DiskFree(cislo_disku);
    DSA:=trunc(DSA/1000);
    DFA:=trunc(DFA/1000);
   END
  ELSE
   BEGIN
    DSA:=-1;
    DFA:=-1;
    clrscr;
    IF(cislo_disku>2)
    THEN write('Hard disk nen dostupn !')
    ELSE write('Disketa nen dostupn !');
    clrscr;
   END;

  Misto:=DFA;

  {$I+}

 END; { ... Misto_disk ************************************}


end.