unit IOBW;
interface
uses winCRT;
const BA = $3F8;                           { COM 1 }

procedure COM1;
procedure COM2;
procedure COM3;
procedure COM4;
procedure reset;
procedure Vystup(dout :byte;var vst:byte);
procedure Vstup(var vst:byte);
procedure vstup_c(pomoc:integer);
function in1(vst:byte):byte;
function in2(vst:byte):byte;
function in3(vst:byte):byte;
function in4(vst:byte):byte;
function in5(vst:byte):byte;
function in6(vst:byte):byte;
function in7(vst:byte):byte;
function in8(vst:byte):byte;

implementation

procedure COM1;
const BA=$3F8;
begin
end;


procedure COM2;
const BA=$2F8;
begin
end;

procedure COM3;
const BA=$3E8;
begin
end;

procedure COM4;
const BA=$2E8;
begin
end;

procedure reset;
var Dout, Din, Ain : Byte;
    Stelle, StelleAD, n, m  : Integer;
begin
  dout := 255;
  Port [BA+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                       { Verzgerung }
  Port [BA+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  StelleAD := 128;
  Din := 0;
  Ain := 0;
  for n:=1 to 8 do begin
    if ((Dout AND Stelle) > 0) then
      Port [BA+3] := 64                    { Daten ausgeben (TXD) }
      else Port [BA+3] := 0;
    if (Port[BA+6] AND 128) = 128          { Daten lesen (DCD) }
       then Din := Din + Stelle;
    if (Port[BA+6] AND 32) = 32 then       { A/D lesen (DSR) }
       Ain := Ain + StelleAD;
    Port [Ba+4] := 1;                      { Clock an (DTR) }
    Stelle := Stelle * 2;
    StelleAD := StelleAD div 2;
    Port [BA+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA+4] := 0;                        { Strobe aus (RTS) }
  dout := 0;
end;

procedure Vystup(dout :byte;var vst:byte);
var Stelle, StelleAD, n, m  : Integer;
begin
  Port [BA+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                       { Verzgerung }
  Port [BA+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  vst := 0;
  for n:=1 to 8 do begin
    if ((Dout AND Stelle) > 0) then
      Port [BA+3] := 64                    { Daten ausgeben (TXD) }
      else Port [BA+3] := 0;
    if (Port[BA+6] AND 128) = 128          { Daten lesen (DCD) }
       then vst := vst + Stelle;
    Port [Ba+4] := 1;                      { Clock an (DTR) }
    Stelle := Stelle * 2;
    for m:=1 to 10 do;
    Port [BA+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA+4] := 0;                        { Strobe aus (RTS) }
end;


procedure Vstup(var vst:byte);
var Stelle, StelleAD,m, n : Integer;
begin
  Port [BA+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                       { Verzgerung }
  Port [BA+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  vst := 0;
  for n:=1 to 8 do begin
    {if ((Dout AND Stelle) > 0) then
      Port [BA+3] := 64                    { Daten ausgeben (TXD) }
{      else Port [BA+3] := 0;}
    if (Port[BA+6] AND 128) = 128          { Daten lesen (DCD) }
       then vst := vst + Stelle;
    Port [Ba+4] := 1;                      { Clock an (DTR) }
    Stelle := Stelle * 2;
    for m:=1 to 10 do;
    Port [BA+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA+4] := 0;                        { Strobe aus (RTS) }
end;


procedure vstup_c(pomoc:integer);
var v1,v2,v3,v4,v5,v6,v7,v8 : integer;
                 n : integer;
begin
  write('Sepnuli jste vstup(y): ');
  clreol;
  v1:=0;
  v2:=0;
  v3:=0;
  v4:=0;
  v5:=0;
  v6:=0;
  v7:=0;
  v8:=0;
  if pomoc = 255 then write('dn ');
  if pomoc mod 2 =0 then begin v1:=1;write(v1,' '); end;
  if pomoc div 2 mod 2 =0 then begin v2:=2; write(v2,' '); end;
  if pomoc div 4 mod 2 =0 then begin v3:=3;write(v3,' '); end;
  if pomoc div 8 mod 2 =0 then begin v4:=4;write(v4,' '); end;
  if pomoc div 16 mod 2 =0 then begin v5:=5;write(v5,' '); end;
  if pomoc div 32 mod 2 =0 then begin v6:=6;write(v6,' '); end;
  if pomoc div 64 mod 2 =0 then begin v7:=7;write(v7,' '); end;
  if pomoc div 128 mod 2 =0 then begin v8:=8;write(v8,' '); end;
  if
  pomoc = 0 then write(' vechny');
end;


function in1(vst:byte):byte;
begin
in1:=0;
if vst mod 2 = 0 then in1:=1;
end;

function in2(vst:byte):byte;
begin
in2:=0;
if vst div 2 mod 2 = 0 then in2:=1;
end;


function in3(vst:byte):byte;
begin
in3:=0;
if vst div 4 mod 2 = 0 then in3:=1;
end;

function in4(vst:byte):byte;
begin
in4:=0;
if vst div 8 mod 2 = 0 then in4:=1;
end;

function in5(vst:byte):byte;
begin
in5:=0;
if vst div 16 mod 2 = 0 then in5:=1;
end;

function in6(vst:byte):byte;
begin
in6:=0;
if vst div 32 mod 2 = 0 then in6:=1;
end;

function in7(vst:byte):byte;
begin
in7:=0;
if vst div 64 mod 2 = 0 then in7:=1;
end;

function in8(vst:byte):byte;
begin
in8:=0;
if vst div 128 mod 2 = 0 then in8:=1;
end;


end.